# SEO Helper [![Packagist License][badge_license]](LICENSE.md) [![For PHP][badge_php]][link-github-repo]

[![Github Workflow Status][badge_build]][link-github-status]
[![Coverage Status][badge_coverage]][link-scrutinizer]
[![Scrutinizer Code Quality][badge_quality]][link-scrutinizer]
[![SensioLabs Insight][badge_insight]][link-insight]
[![Github Issues][badge_issues]][link-github-issues]

[![Packagist][badge_package]][link-packagist]
[![Packagist Release][badge_release]][link-packagist]
[![Packagist Downloads][badge_downloads]][link-packagist]

*By [ARCANEDEV&copy;](http://www.arcanedev.net/)*

SEO Helper is a package that provides tools and helpers for SEO (Search Engine Optimization).

Feel free to check out the [releases](https://github.com/ARCANEDEV/SEO-Helper/releases), [license](LICENSE.md), and [contribution guidelines](CONTRIBUTING.md).

### Features

  * Framework agnostic package.
  * Open Graph &amp; Twitter Cards are supported.
  * Webmaster tools site verifier tags are supported.
  * Google Analytics tracking code is supported.
  * Easy setup &amp; configuration.
  * Well documented &amp; IDE Friendly.
  * Well tested with maximum code quality.
  * Laravel `5.x` to `8.x` are supported.
  * Made with :heart: &amp; :coffee:.

## Table of contents

  1. [Installation and Setup](_docs/1-Installation-and-Setup.md)
  2. [Configuration](_docs/2-Configuration.md)
  3. [Usage](_docs/3-Usage.md)
  4. [API](_docs/4-API.md)
  5. [Extras](_docs/5-Extras.md)

## Contribution

Any ideas are welcome. Feel free to submit any issues or pull requests, please check the [contribution guidelines](CONTRIBUTING.md).

## Security

If you discover any security related issues, please email arcanedev.maroc@gmail.com instead of using the issue tracker.

## Credits

- [ARCANEDEV][link-author]
- [All Contributors][link-contributors]

[badge_php]:          https://img.shields.io/badge/PHP-Framework%20agnostic-4F5B93.svg?style=flat-square
[badge_license]:      https://img.shields.io/packagist/l/arcanedev/seo-helper.svg?style=flat-square
[badge_build]:        https://img.shields.io/github/workflow/status/ARCANEDEV/SEO-Helper/run-tests?style=flat-square
[badge_coverage]:     https://img.shields.io/scrutinizer/coverage/g/ARCANEDEV/SEO-Helper.svg?style=flat-square
[badge_quality]:      https://img.shields.io/scrutinizer/g/ARCANEDEV/SEO-Helper.svg?style=flat-square
[badge_insight]:      https://img.shields.io/sensiolabs/i/73e1a779-7ca7-4a75-b6d3-452d7852187e.svg?style=flat-square
[badge_issues]:       https://img.shields.io/github/issues/ARCANEDEV/SEO-Helper.svg?style=flat-square
[badge_package]:      https://img.shields.io/badge/package-arcanedev/seo--helper-blue.svg?style=flat-square
[badge_release]:      https://img.shields.io/packagist/v/arcanedev/seo-helper.svg?style=flat-square
[badge_downloads]:    https://img.shields.io/packagist/dt/arcanedev/seo-helper.svg?style=flat-square

[link-author]:        https://github.com/arcanedev-maroc
[link-github-repo]:   https://github.com/ARCANEDEV/SEO-Helper
[link-github-status]: https://github.com/ARCANEDEV/SEO-Helper/actions
[link-github-issues]: https://github.com/ARCANEDEV/SEO-Helper/issues
[link-contributors]:  https://github.com/ARCANEDEV/SEO-Helper/graphs/contributors
[link-packagist]:     https://packagist.org/packages/arcanedev/seo-helper
[link-scrutinizer]:   https://scrutinizer-ci.com/g/ARCANEDEV/SEO-Helper/?branch=master
[link-insight]:       https://insight.sensiolabs.com/projects/73e1a779-7ca7-4a75-b6d3-452d7852187e
